window.onload = function () {
    // Grab the data
    var labels = [],
        long_labels = [],
        data = [],
        formatted_data = [];
    $("#data .data_label").each(function () {
        labels.push($(this).html());
    });
    $("#data .data_label_long").each(function () {
        long_labels.push($(this).html());
    });
    $("#data .data_value").each(function () {
        data.push($(this).html());
    });
    $("#data .data_value_formatted").each(function () {
        formatted_data.push($(this).html());
    });
    
    // Draw
    var width = graph_width,
        height = graph_height,
        leftgutter = 0,
        bottomgutter = 30,
        topgutter = 20,
        colorhue = .6 || Math.random(),
        color = "hsb(" + [colorhue, 1, .75] + ")",
        r = Raphael("holder", width, height),
        txt = {"font": '12px "Lucida Grande"', stroke: "none", fill: "#fff"},
        txt1 = {"font": '9px "Lucida Grande"', stroke: "none", fill: "#000"},
        txt2 = {"font": '12px "Lucida Grande"', stroke: "none", fill: "#000"},
        X = (width - leftgutter) / labels.length,
        max = Math.max.apply(Math, data),
        max = max + (max * .10),
        Y = (height - bottomgutter - topgutter) / max;
        
        // draw the background
        var backgroundTopColor = "#000";
        var backgroundBottomColor = "#515160";
        var theBackground = r.rect(0, 0, width, height);
        theBackground.attr({gradient: "90-"+backgroundBottomColor+"-"+backgroundTopColor+"", opacity: 1.0})
        
    r.drawGrid(leftgutter + X * .5 +.5, topgutter + .5, width - leftgutter - X, height - topgutter - bottomgutter, 0, 5, "#fff");
    var path = r.path({stroke: color, "stroke-width": 4, "stroke-linejoin": "round"}),
        bgp = r.path({stroke: "none", opacity: .3, fill: color}).moveTo(leftgutter + X * .5, height - bottomgutter),
        frame = r.rect(10, 10, 100, 40, 5).attr({fill: "#111", stroke: "#fff", "stroke-width": 1}).hide(),
        label = [],
        is_label_visible = false,
        leave_timer,
        blanket = r.set();
    label[0] = r.text(60, 10, "24").attr(txt).hide();
    label[1] = r.text(60, 40, "22").attr(txt1).attr({fill: color}).hide();

    for (var i = 0, ii = labels.length; i < ii; i++) {
        var y = Math.round(height - bottomgutter - Y * data[i]),
            x = Math.round(leftgutter + X * (i + .5)),
            t = r.text(x, height - 18, labels[i]).attr(txt).toBack();
        bgp[i == 0 ? "lineTo" : "cplineTo"](x, y, 10);
        path[i == 0 ? "moveTo" : "cplineTo"](x, y, 10);
        var dot = r.circle(x, y, 5).attr({fill: color, stroke: "#000"});
        blanket.push(r.rect(leftgutter + X * i, 0, X, height - bottomgutter).attr({stroke: "none", fill: "#fff", opacity: 0}));
        var rect = blanket[blanket.length - 1];
        (function (x, y, data, lbl, dot) {
            var timer, i = 0;
            $(rect.node).hover(function () {
                clearTimeout(leave_timer);
                var newcoord = {x: x * 1 + 7.5, y: y - 19};
                if (newcoord.x + 100 > width) {
                    newcoord.x -= 114;
                }
                frame.show().animate({x: newcoord.x, y: newcoord.y}, 200 * is_label_visible);
                label[0].attr({text: data}).show().animate({x: newcoord.x * 1 + 50, y: newcoord.y * 1 + 12}, 200 * is_label_visible);
                label[1].attr({text: lbl + ""}).show().animate({x: newcoord.x * 1 + 50, y: newcoord.y * 1 + 27}, 200 * is_label_visible);
                dot.attr("r", 7);
                is_label_visible = true;
                r.safari();
            }, function () {
                dot.attr("r", 5);
                r.safari();
                leave_timer = setTimeout(function () {
                    frame.hide();
                    label[0].hide();
                    label[1].hide();
                    is_label_visible = false;
                    r.safari();
                }, 1);
            });
        })(x, y, formatted_data[i], long_labels[i], dot);
    }
    bgp.lineTo(x, height - bottomgutter).andClose();
    frame.toFront();
    label[0].toFront();
    label[1].toFront();
    blanket.toFront();
    theBackground.toBack();
};